As a security precaution, we have turned on the setting "Require API key authentication for API requests" for everyone. If this has broken something, please contact bugzilla-admin@mozilla.org
Last Comment Bug 746217 - Cannot open windows even from the same domain
: Cannot open windows even from the same domain
Status: VERIFIED FIXED
[marketplace-beta-]
:
Product: Firefox Graveyard
Classification: Graveyard
Component: Webapp Runtime (show other bugs)
: unspecified
: All All
: -- critical
: ---
Assigned To: Ed Lee :Mardak
: Jason Smith [:jsmith]
:
Mentors:
Depends on: 725408 732631
Blocks: 738816
  Show dependency treegraph
 
Reported: 2012-04-17 10:26 PDT by Ed Lee :Mardak
Modified: 2016-03-21 12:39 PDT (History)
5 users (show)
jsmith: in‑moztrap+
See Also:
QA Whiteboard:
Iteration: ---
Points: ---


Attachments
wip v1 (882 bytes, patch)
2012-04-18 10:06 PDT, Ed Lee :Mardak
no flags Details | Diff | Splinter Review

Description User image Ed Lee :Mardak 2012-04-17 10:26:19 PDT
When I try to call window.open("http://ed.agadak.net") from http://ed.agadak.net/app/

I get an exception:

[Exception... "Component returned failure code: 0x80004005 (NS_ERROR_FAILURE) [nsIDOMJSWindow.open]" nsresult: "0x80004005 (NS_ERROR_FAILURE)" location: "JS frame :: http://ed.agadak.net/app/ :: onClick :: line 26" data: no] 

This is problematic for the Marketplace app for bug 738816 which relies on Persona for login and that opens up a new window.
Comment 1 User image Jason Smith [:jsmith] 2012-04-17 13:42:36 PDT
I wonder if the underlying issue is similar to bug 729853? I know there's been a lot of problems with being able to open pop-ups, windows, or anything that steps outside of the initial chromeless content presented to a user.
Comment 2 User image Ed Lee :Mardak 2012-04-17 15:12:46 PDT
I get these warnings when trying to open a window from an app:

WARNING: NS_ENSURE_TRUE(xulWin->mPrimaryContentShell) failed: file /builds/slave/try-osx64-dbg/build/xpfe/appshell/src/nsXULWindow.cpp, line 1810
WARNING: NS_ENSURE_SUCCESS(rv, rv) failed with result 0x80004005: file /builds/slave/try-osx64-dbg/build/dom/base/nsGlobalWindow.cpp, line 8927

The latter one is in OpenInternal..
http://mxr.mozilla.org/mozilla-central/source/dom/base/nsGlobalWindow.cpp#8682
.. on this line..
http://mxr.mozilla.org/mozilla-central/source/dom/base/nsGlobalWindow.cpp#8823

The former is in CreateNewContentWindow..
http://mxr.mozilla.org/mozilla-central/source/xpfe/appshell/src/nsXULWindow.cpp#1759
.. on this line..
http://mxr.mozilla.org/mozilla-central/source/xpfe/appshell/src/nsXULWindow.cpp#1810
Comment 3 User image Ed Lee :Mardak 2012-04-18 09:55:54 PDT
I have a tryserver debug build that has windows opening, but the main window no longer scrolls. This was just changing the <xul:browser type="content-primary"> instead of just type="content".

https://ftp.mozilla.org/pub/mozilla.org/firefox/try-builds/edward.lee@engineering.uiuc.edu-45e9879bb692/try-macosx64-debug/firefox-14.0a1.en-US.mac64.dmg

--- a/webapprt/content/webapp.xul
+++ b/webapprt/content/webapp.xul
@@ -151,1 +151,1 @@
-  <browser type="content" id="content" flex="1"/>
+  <browser type="content-primary" id="content" flex="1"/>

This build lets me log into Marketplace with Persona through the newly opened window, but the only way I can scroll in the main window is by clicking the page and using arrows/spacebar (mousescroll doesn't work and no scrollbars to drag).
Comment 4 User image Ed Lee :Mardak 2012-04-18 10:06:50 PDT
Created attachment 616186 [details] [diff] [review]
wip v1

Allows opening windows but first window doesn't have scrollbars.
Comment 5 User image Jason Smith [:jsmith] 2012-04-18 10:11:58 PDT
Felipe or Myk - Could you look at this?
Comment 6 User image Jennifer Arguello :ticachica 2012-04-18 17:01:03 PDT
Would be nice to know how many apps this effects. Leaving it as a blocker for now, but since there is a way to navigate the window manually I'm saying a "soft" blocker.
Comment 7 User image Jason Smith [:jsmith] 2012-04-18 17:23:39 PDT
Investigation needed on the following applications:

- Backpack
- Basecamp
- Campfire
- Highrise
- Ta-Da List
- Lord of Ultima
- Soundcloud
- Times Crossword
- Sky Guide
Comment 8 User image Myk Melez [:myk] [@mykmelez] 2012-04-19 17:47:51 PDT
Changing the browser type to content-primary doesn't prevent scrolling in an app I'm using to test.  So maybe the scrolling problem is app-specific.

Mardak: how can I install your app?  I went to http://ed.agadak.net/app/, and it wasn't clear how to install the app from there.
Comment 9 User image Ed Lee :Mardak 2012-04-19 18:35:17 PDT
The manifest is at http://ed.agadak.net/manifest.webapp, and I've just been installing it through the web console in Firefox:

navigator.mozApps.install("http://ed.agadak.net/manifest.webapp")

There's various links on the page where you can navigate away, e.g., to youtube, and the page doesn't have scrollbars. But even without navigation, the marketplace app loses its scrollbars for me on the initial load.

navigator.mozApps.install("http://marketplace-dev.allizom.org/manifest.webapp")
Comment 10 User image Jason Smith [:jsmith] 2012-04-24 20:53:23 PDT
Based on testing so far, i haven't seen this bug occur often involving the "same" domain. Usually so far I've seen a higher likelihood when it's opening a pop-up or window on a different domain. I don't think this is a marketplace beta blocker.
Comment 11 User image Jason Smith [:jsmith] 2012-04-30 10:20:11 PDT
Ed - Is this fixed as a result of the bug dependency?
Comment 12 User image Ed Lee :Mardak 2012-04-30 10:21:24 PDT
Fixed by bug 732631.

https://hg.mozilla.org/mozilla-central/rev/c8f67f81e8df
Comment 13 User image Jason Smith [:jsmith] 2012-04-30 16:27:56 PDT
Verified on windows 7 64-bit and OS X 10.6.8.

Note You need to log in before you can comment on or make changes to this bug.